#include <Servo.h>

//inverse
Servo servo1; 
Servo servo6; 

//regular
Servo servo3; 
Servo servo4; 

// full range reg
Servo servo2; 

//full range inv
Servo servo5; 

int startPos[] = {95, 179, 88, 93, 15, 87};
int offset[] = {87, -173, -85, -83, 159, 92};

void setup() {
  //servo1.setMaximumPulse(2000);
  //servo1.setMinimumPulse(700); 
  
  servo1.write(startPos[0]);
  servo2.write(startPos[1]);
  servo3.write(startPos[2]);
  servo4.write(startPos[3]);
  servo5.write(startPos[4]);
  servo6.write(startPos[5]); 
 
  servo1.attach(2);  
  servo2.attach(3);  
  servo3.attach(4);
  servo4.attach(7);  
  servo5.attach(6);
  servo6.attach(5); 
  
  initSerial();
  
}
 /*
  * This program uses the Arduino Pro Mini hardware serial (RX+TX pin) and not SoftwareSerial.
  * The interrupts of SoftwareSerial interfere with the Servo library, resulting in servo twitching.
  * It can be partly fixed by increasing the baud rate and detaching / attaching the servos before receiving data.
  * However, twitching does not go away completely. Therefore, hardware serial. [DL, 2015-06-02]
  */
void initSerial()
{
  Serial.begin(57600);
  Serial.println("starting...");  
}

void loop() 
{
  char data [3];

  if ( Serial.available() >= 3) 
  {    
    Serial.readBytes(data,3); 
     
    int value = atoi(&data[1]);    
    
    int motor = data[0];
    motor = motor - 48; //ASCII conversion
   
/*
    Serial.print("input: ");
    Serial.print(value);
    Serial.print(" / motor :");
    Serial.println(motor);
*/

    if(value < 0)
      value = 0;
      
    if(value > 99)
      value = 99;
      
    float ratio = ((float)value) / 99.0;
      
    switch(motor)
    {
       case 0:
          servo1.write(startPos[0] + ratio * offset[0]);
          servo2.write(startPos[1] + ratio * offset[1]);
          servo3.write(startPos[2] + ratio * offset[2]);
          servo4.write(startPos[3] + ratio * offset[3]);
          servo5.write(startPos[4] + ratio * offset[4]);
          servo6.write(startPos[5] + ratio * offset[5]);
          break;
       case 1:
          servo1.write(startPos[0] + ratio * offset[0]);
          break;
       case 2:
          servo2.write(startPos[1] + ratio * offset[1]);
          break;
       case 3:
          servo3.write(startPos[2] + ratio * offset[2]);
          break;
       case 4:
          servo4.write(startPos[3] + ratio * offset[3]);
          break;   
       case 5:
          servo5.write(startPos[4] + ratio * offset[4]);
          break;   
       case 6:
          servo6.write(startPos[5] + ratio * offset[5]);
          break;     
    }
  }

} 
