package communication;

/**
 * Created by dalind on 01/06/15.
 */
import jssc.SerialPort;
import processing.core.PApplet;
import processing.serial.*;

import javax.sql.rowset.serial.SerialRef;

public class ConnectionUtil
{
    int selectedPort = -1;
    public boolean isConnected;
    boolean serialPortSelected;

    PApplet host;

    public Serial serial;

    public ConnectionUtil(PApplet applet)
    {
        host = applet;
        selectedPort = -1;
        isConnected = false;
        serialPortSelected = false;
    }

    public String[] getPortList()
    {
        return Serial.list();
    }

    public void handlePortSelection(int portNumber)
    {
        selectedPort = portNumber;
        host.println("set port to " + portNumber);
        serialPortSelected = true;
    }

    public  boolean connect()
    {
        if(isConnected || !serialPortSelected)
            return false;


        host.println("trying to connect to port " + Serial.list()[selectedPort]);

        try {
            serial = new Serial(host, Serial.list()[selectedPort], 57600);
        } catch (Exception e) {
            System.err.println("JE: processing port error");
            e.printStackTrace();
            return false;
        }

        host.println("connected to port " + Serial.list()[selectedPort]);

        isConnected = true;
        return true;
    }

    public void disconnect()
    {
        if(!isConnected)
            return;

        serial.stop();
        isConnected = false;

        host.println("disconnected serial");
    }
}