package communication;

import processing.core.PApplet;

/**
 * Created by dalind on 01/06/15.
 */
public class DataUtil {

    public static final int MOTOR_MIN_VALUE = 0;
    public static final int MOTOR_MAX_VALUE = 99;

    private static final double epsilon = .0001;

    public int lastValueSent = -1;
    public int lastMotorSent = -1;

    PApplet host;
    ConnectionUtil connection;

    public DataUtil(PApplet applet, ConnectionUtil connectionUtil)
    {
        host = applet;
        connection = connectionUtil;
    }

    /*
     *   Motor is 0 for all motors, 1-4 for specific ones;
     *   Value is between 0 and 100;
     */
    public void write(int motor, int value)
    {
        if(Math.abs(value - lastValueSent) < epsilon &&
                Math.abs(motor - lastMotorSent) < epsilon)
            return;

        lastMotorSent = motor;
        lastValueSent = value;

        char[] bytes = new char[3];

        if(value > MOTOR_MAX_VALUE)
            value = MOTOR_MAX_VALUE;

        if(value < MOTOR_MIN_VALUE)
            value = MOTOR_MIN_VALUE;

        //+47 for ASCII conversion
        bytes[0] = (char)(int)(motor + 48);
        bytes[1] = (char)(value / 10 + 48);
        bytes[2] = (char)(value % 10 + 48);

        String data = new String(bytes);
        write(data);
    }

    public void write(String data) {
        host.println("sending: " + data);

        if(connection.isConnected)
            connection.serial.write(data);
        else
            host.println("not connected");
    }

    public void receiveData()
    {
        if(connection == null || !connection.isConnected)
            return;

        boolean receivedData = false;

        while (connection.serial.available() > 0)
        {
            String inBuffer = connection.serial.readString();
            if(inBuffer != null)
            {
                host.println(inBuffer);
                receivedData = true;
            }
        }
        if(receivedData)
            host.println("received");
    }

}
